package com.sxtvs.open.api.clue.service.impl;

import cn.hutool.http.HttpUtil;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import static com.sxtvs.open.core.conf.Constant.weixinGZHAppid;
import static com.sxtvs.open.core.conf.Constant.weixinGZHSecret;

public class WxTokenCache {
    private String accessToken;

    private static WxTokenCache wxTokenCache;

    private WxTokenCache(){

    }

    public static WxTokenCache getInstance(){
        if(wxTokenCache == null){
            wxTokenCache = new WxTokenCache();
            wxTokenCache.setAccessToken();
        }
        return wxTokenCache;
    }

    public void setAccessToken(){
        String response = HttpUtil.get("https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=" + weixinGZHAppid + "&secret=" + weixinGZHSecret);
        ObjectMapper objectMapper = new ObjectMapper();
        try {
            this.accessToken = objectMapper.readTree(response).get("access_token").asText();
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
    }

    public String getAccessToken() {
        return accessToken;
    }
}
